<script lang="ts">
  import CardInline from "./CardInline.svelte";
  import type { Speech } from "../server";
  import { CardFace } from "../server";

  export let speech: Speech;

  $: playedCard = getPlayedCard(speech);

  function getPlayedCard(speech: Speech): CardFace | null {
    switch (speech.kind) {
      case "PlayCard":
        return speech.card;
      case "NoEffect":
        return speech.card;
      case "Guess":
        return CardFace.C1;
      case "Peek":
        return CardFace.C2;
      case "Compare":
        return CardFace.C3;
      case "Discard":
        return CardFace.C5;
      case "Swap":
        return CardFace.C7;
      case "GuessResponse":
        return null;
    }
  }
  function hasFollowup(speech: Speech) {
    return (
      speech.kind === "PlayCard" &&
      [
        CardFace.C1,
        CardFace.C2,
        CardFace.C3,
        CardFace.C5,
        CardFace.C7,
      ].includes(speech.card)
    );
  }
</script>

<div class="speech">
  {#if playedCard !== null}
    I play
    <CardInline card={playedCard} suffix="!" />
  {/if}

  {#if speech.kind === "NoEffect"}
    It has no effect because everyone is
    <span class="protected">
      <span class="emoji">🛡</span>
      protected.
    </span>
  {/if}

  {#if speech.kind === "Guess"}
    <div class="followup">
      I think
      <gs6-user playerid={speech.target} />
      has a
      <CardInline card={speech.guess} suffix="." />
    </div>
  {/if}

  {#if speech.kind === "GuessResponse" && speech.correct}
    You're right!
  {:else if speech.kind === "GuessResponse" && !speech.correct}Wrong!{/if}

  {#if speech.kind === "Peek"}
    <div class="followup">
      Show me your card,
      <gs6-user playerid={speech.target} suffix="!" />
    </div>
  {/if}

  {#if speech.kind === "Compare"}
    <div class="followup">
      I'm comparing hands with
      <gs6-user playerid={speech.target} suffix="!" />
    </div>
  {/if}

  {#if speech.kind === "Discard"}
    <div class="followup">
      <gs6-user playerid={speech.target} />
      must discard their hand!
    </div>
  {/if}

  {#if speech.kind === "Swap"}
    <div class="followup">
      Let's swap hands,
      <gs6-user playerid={speech.target} suffix="!" />
    </div>
  {/if}
</div>
{#if hasFollowup(speech)}
  <div class="followup">…</div>
{/if}

<style>
  .speech {
    text-align: center;
  }
  .followup {
    text-align: center;
    margin-top: 0.5em;
  }

  .protected {
    white-space: nowrap;
    font-weight: 500;
  }
</style>
